import numpy as np
import tensorflow as np
import tensorflow.keras as k

# You can build your model for the last part of the homework here or elsewhere.
# The method below can be used to generate the required csv file.


def save_csv(x, filename="submission.csv"):
    """save_csv Save the input into csv file

    Arguments:
        x {np.ndarray} -- input array

    Keyword Arguments:
        filename {str} -- The file name (default: {"submission.csv"})

    Raises:
        ValueError: Input data structure is not np.ndarray
    """
    if isinstance(x, np.ndarray):
        x = x.flatten()
        np.savetxt(filename, x, delimiter=',')
    else:
        raise ValueError("The input is not an np.ndarray")
