# %%
# Part II Numpy implementations
import numpy as np
import hw2_utils


def convolution(x, w, b, stride, pad):
    """
    4.1 Understanding Convolution
    Forward Pass for a convolution layer.
    The input consists of N data points, each with C channels, height H and
    width W. We convolve each input with F different filters, where each filter
    spans all C channels and has height HH and width HH.

    Input:
    - x: Input data of shape (N, C, H, W)
    - w: Filter weights of shape (F, C, HH, WW)
    - b: Biases, of shape (F,)
    - 'stride': The number of pixels between adjacent receptive fields in the
        horizontal and vertical directions.
    - 'pad': The number of pixels that will be used to zero-pad the input.

    Output:
    - out: Output of the forward pass
    """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    out = None

    ###########################################################################
    # Your code starts here
    ###########################################################################
    # TODO 4.1 Understanding Convolution

    ###########################################################################
    # END OF YOUR CODE
    ###########################################################################

    return out


def grayscale_filter(w):
    """ your grayscale filter

    Modify the second filter of the input filters as a grayscale filter

    Input:
    - w: Conv filter of shape [2, 3, 3, 3]

    Output:
    - w: The modified filter

    """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    ###########################################################################
    # Your code starts here
    ###########################################################################

    pass

    ###########################################################################
    # END OF YOUR CODE
    ###########################################################################

    return w


def relu(x):
    """
    4.2 ReLU Implementation
    Computes the forward pass for a layer of rectified linear units (ReLUs).

    Input:
    - x: Inputs, of any shape

    Returns a tuple of:
    - out: Output, of the same shape as x
    """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    out = None

    ###########################################################################
    # Your code starts here
    ###########################################################################
    # TODO: 4.2 ReLU Implementation

    pass

    ###########################################################################
    # END OF YOUR CODE
    ###########################################################################

    return out


def max_pool(x, pool_param):
    """
    4.3 MaxPooling Implementation
    A naive implementation of the forward pass for a max-pooling layer.

    Inputs:
    - x: Input data, of shape (N, C, H, W)
    - pool_param: dictionary with the following keys:
      - 'pool_height': The height of each pooling region
      - 'pool_width': The width of each pooling region
      - 'stride': The distance between adjacent pooling regions

    Returns a tuple of:
    - out: Output data
    """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    out = None

    ###########################################################################
    # Your code starts here
    ###########################################################################
    # TODO: 4.3 MaxPooling Implementation

    pass

    ###########################################################################
    # END OF YOUR CODE
    ###########################################################################

    return out


def dropout(x, mode, p):
    """
    4.4  Dropout Implementation
    Performs the forward pass for (inverted) dropout.
    Inputs:
    - x: Input data, of any shape
    - p: Dropout parameter. We drop each neuron output with probability p.
    - mode: 'test' or 'train'. If the mode is train, then perform dropout;
    if the mode is test, then just return the input.
    Outputs:
    - out: Array of the same shape as x.
    """

    hw2_utils.exercise(
        andrew_username="pmardzie", # <<< set your andrew username here
        seed=42
    )

    out = None

    if mode == 'train':
        #######################################################################
        # Your code starts here
        #######################################################################
        # TODO: 4.3 MaxPooling Implementation

        pass

        #######################################################################
        # END OF YOUR CODE
        #######################################################################

    elif mode == 'test':
        #######################################################################
        # Your code starts here
        #######################################################################
        # TODO: 4.3 Test mode of dropout

        pass

        #######################################################################
        # END OF YOUR CODE
        #######################################################################

    return out
